/*  AvalonExport1.v
  Started Jan 2012 by Alan Stummer, University of Toronto
  DESCRIPTION:  Exports the Avalon bus for Nios II on Qsys.
  
  This version has 32-bit data bus and 5-bit address with simple CS, /RD and /WR bits.
*/

`timescale 1 ps / 1 ps

module AvalonExport (
	//Avalon I/Os, connected to Qsys Avalon bus
	input         ClkIn,
	input         ResetIn,
	output [31:0] AvalonDataRdIn,									   //ext module writes to this bus.
	input  [31:0] AvalonDataWrIn,									  //ext module reads from this bus.
	input  [ 4:0] AvalonAddrIn,
	input         AvalonCsIn,
	input         AvalonReadEnIn,
	input         AvalonWriteEnIn,
	//external module I/Os, exported by Qsys
	output        ClkOut,										 //ext module uses this for Avalon.
	output        ResetOut,													//ext module gets this.
	input  [31:0] AvalonDataRdOut,								   //ext module writes to this bus.
	output [31:0] AvalonDataWrOut,								  //ext module reads from this bus.
	output [ 4:0] AvalonAddrOut,
	output        AvalonCsOut,
	output        AvalonReadEnOut,
	output        AvalonWriteEnOut
	);

	//Plumbing
	assign ClkOut           = ClkIn;
	assign ResetOut         = ResetIn;
	assign AvalonDataRdIn   = AvalonDataRdOut;
	assign AvalonDataWrOut  = AvalonDataWrIn;
	assign AvalonAddrOut    = AvalonAddrIn;
	assign AvalonCsOut      = AvalonCsIn;
	assign AvalonReadEnOut  = AvalonReadEnIn;
	assign AvalonWriteEnOut = AvalonWriteEnIn;
	
endmodule

